package net.sf.sql2java.data.holders;

import java.util.List;

import net.sf.sql2java.data.MapPointer;
import net.sf.sql2java.data.Path;
import net.sf.sql2java.data.node.BasicNodelet;

public class Index extends BasicNodelet {
	private static final long serialVersionUID = 6209424595465181458L;

	private String qualifier;
	private boolean unique;
	
// -- Constructors ------------------------------------------------------------
	
	public Index(String name) {
		super("index", name);
	}
	
// -- Columns -----------------------------------------------------------------
	
	public IndexColumn createColumn(Column column) {
		// -- create the result
		IndexColumn result = new IndexColumn(column);
		
		// -- save the result
		saveColumn(result);
		
		// -- return the result
		return result;
	}
	
	public void saveColumn(IndexColumn indexColumn) {
		put(indexColumn);
	}
	
	public void removeColumn(String columnName) {
		String strPath = String.format(MapPointer.FORMAT, "indexColumn", columnName);
		
		remove(Path.createPath(strPath));
	}
	
	public IndexColumn getColumn(String columnName) {
		String strPath = String.format(MapPointer.FORMAT, "indexColumn", columnName);
		
		return (IndexColumn) get(Path.createPath(strPath));
	}

// -- Getters -----------------------------------------------------------------
	
	public boolean isUnique() {
		return unique;
	}

	public List<IndexColumn> getColumns() {
		return list(Path.createPath("indexColumn"));
	}
	
	public String getQualifier() {
		return qualifier;
	}
	
	public Table getTable() {
		if (getParent() == null) return null;
		else return (Table) getParent();
	}

// -- Setters -----------------------------------------------------------------
	
	public void setUnique(boolean unique) {
		this.unique = unique;
	}

	public void setQualifier(String qualifier) {
		this.qualifier = qualifier;
	}
}
