package net.sf.sql2java.data.node;

import java.util.List;
import java.util.Map;

import net.sf.sql2java.data.Path;

public interface Nodelet {
	
	public <T extends Nodelet> T getParent();
	
	public String getName();
	
	public String getType();
	
	public void setParent(Nodelet parent);
	
	public Map<String, Nodelet> get(String key);
	
	public <T extends Nodelet> T get(Path path);
	
	public <T extends Nodelet> List<T> list(Path path);
	
	public void put(Path path, Nodelet node);
	
	public void put(Nodelet node);
	
	public void put(String key, Map<String, Nodelet> value);
	
	public void remove(Path path);
	
	public boolean exists(Path path);
	
	public Map<String, Map<String, Nodelet>> getChildren();
}
